Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mortbay.io.nio
Class SelectorManager

    java.lang.Object
      org.mortbay.component.AbstractLifeCycle
          org.mortbay.io.nio.SelectorManager

All Implemented Interfaces:
  LifeCycle

    public abstract class SelectorManager

extends AbstractLifeCycle

The Selector Manager manages and number of SelectSets to allow NIO scheduling to scale to large numbers of connections.

Author:
  gregw

Nested Class Summary
`class` | `SelectorManager.SelectSet`

Nested classes/interfaces inherited from interface org.mortbay.component.LifeCycle
`LifeCycle.Listener`

Field Summary

Fields inherited from class org.mortbay.component.AbstractLifeCycle
`_listeners`

Constructor Summary
`SelectorManager()`

Method Summary
`protected abstract java.nio.channels.SocketChannel` | `acceptChannel(java.nio.channels.SelectionKey key)`
`protected void` | `connectionFailed(java.nio.channels.SocketChannel channel, java.lang.Throwable ex, java.lang.Object attachment)`
`abstract boolean` | `dispatch(java.lang.Runnable task)`
`void` | `doSelect(int acceptorID)`
`protected void` | `doStart()`
`protected void` | `doStop()`
`protected abstract void` | `endPointClosed(SelectChannelEndPoint endpoint)`
`protected abstract void` | `endPointOpened(SelectChannelEndPoint endpoint)`
`long` | `getLowResourcesConnections()`
`long` | `getLowResourcesMaxIdleTime()`
`long` | `getMaxIdleTime()`
`int` | `getSelectSets()`
`boolean` | `isDelaySelectKeyUpdate()`
`protected abstract Connection` | `newConnection(java.nio.channels.SocketChannel channel, SelectChannelEndPoint endpoint)`
`protected abstract SelectChannelEndPoint` | `newEndPoint(java.nio.channels.SocketChannel channel, SelectorManager.SelectSet selectSet, java.nio.channels.SelectionKey sKey)`
`void` | `register(java.nio.channels.ServerSocketChannel acceptChannel)` Register a serverchannel
`void` | `register(java.nio.channels.SocketChannel channel, java.lang.Object att)` Register a channel
`void` | `setDelaySelectKeyUpdate(boolean delaySelectKeyUpdate)`
`void` | `setLowResourcesConnections(long lowResourcesConnections)` Set the number of connections, which if exceeded places this manager in low resources state.
`void` | `setLowResourcesMaxIdleTime(long lowResourcesMaxIdleTime)`
`void` | `setMaxIdleTime(long maxIdleTime)`
`void` | `setSelectSets(int selectSets)`

Methods inherited from class org.mortbay.component.AbstractLifeCycle
`addLifeCycleListener, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SelectorManager

    public SelectorManager()

Method Detail

### setMaxIdleTime

    public void setMaxIdleTime(long maxIdleTime)

  Parameters:
    `maxIdleTime` - The maximum period in milli seconds that a connection may be idle before it is closed.
  See Also:
    `#setLowResourcesMaxIdleTime(long)}`

### setSelectSets

    public void setSelectSets(int selectSets)

  Parameters:
    `selectSets` -

### getMaxIdleTime

    public long getMaxIdleTime()

  Returns:

### getSelectSets

    public int getSelectSets()

  Returns:

### isDelaySelectKeyUpdate

    public boolean isDelaySelectKeyUpdate()

  Returns:

### register

    public void register(java.nio.channels.SocketChannel channel,
                         java.lang.Object att)
                  throws java.io.IOException

  Register a channel

  Parameters:
    `channel` -
    `att` - Attached Object
  Throws:
    `java.io.IOException`

### register

    public void register(java.nio.channels.ServerSocketChannel acceptChannel)
                  throws java.io.IOException

  Register a serverchannel

  Parameters:
    `acceptChannel` -
  Throws:
    `java.io.IOException`

### getLowResourcesConnections

    public long getLowResourcesConnections()

  Returns:
    the lowResourcesConnections

### setLowResourcesConnections

    public void setLowResourcesConnections(long lowResourcesConnections)

  Set the number of connections, which if exceeded places this manager in low resources state. This is not an exact measure as the connection count is averaged over the select sets.

  Parameters:
    `lowResourcesConnections` - the number of connections
  See Also:
    `#setLowResourcesMaxIdleTime(long)}`

### getLowResourcesMaxIdleTime

    public long getLowResourcesMaxIdleTime()

  Returns:
    the lowResourcesMaxIdleTime

### setLowResourcesMaxIdleTime

    public void setLowResourcesMaxIdleTime(long lowResourcesMaxIdleTime)

  Parameters:
    `lowResourcesMaxIdleTime` - the period in ms that a connection is allowed to be idle when this SelectSet has more connections than `getLowResourcesConnections()`
  See Also:
    `#setMaxIdleTime(long)}`

### doSelect

    public void doSelect(int acceptorID)
                  throws java.io.IOException

  Parameters:
    `acceptorID` -
  Throws:
    `java.io.IOException`

### setDelaySelectKeyUpdate

    public void setDelaySelectKeyUpdate(boolean delaySelectKeyUpdate)

  Parameters:
    `delaySelectKeyUpdate` -

### acceptChannel

    protected abstract java.nio.channels.SocketChannel acceptChannel(java.nio.channels.SelectionKey key)
                                                              throws java.io.IOException

  Parameters:
    `key` -
  Returns:
  Throws:
    `java.io.IOException`

### dispatch

    public abstract boolean dispatch(java.lang.Runnable task)
                              throws java.io.IOException

  Throws:
    `java.io.IOException`

### doStart

    protected void doStart()
                    throws java.lang.Exception

  Overrides:
    `doStart` in class `AbstractLifeCycle`
  Throws:
    `java.lang.Exception`

### doStop

    protected void doStop()
                   throws java.lang.Exception

  Overrides:
    `doStop` in class `AbstractLifeCycle`
  Throws:
    `java.lang.Exception`

### endPointClosed

    protected abstract void endPointClosed(SelectChannelEndPoint endpoint)

  Parameters:
    `endpoint` -

### endPointOpened

    protected abstract void endPointOpened(SelectChannelEndPoint endpoint)

  Parameters:
    `endpoint` -

### newConnection

    protected abstract Connection newConnection(java.nio.channels.SocketChannel channel,
                                                SelectChannelEndPoint endpoint)

### newEndPoint

    protected abstract SelectChannelEndPoint newEndPoint(java.nio.channels.SocketChannel channel,
                                                         SelectorManager.SelectSet selectSet,
                                                         java.nio.channels.SelectionKey sKey)
                                                  throws java.io.IOException

  Parameters:
    `channel` -
    `selectSet` -
    `sKey` -
  Returns:
  Throws:
    `java.io.IOException`

### connectionFailed

    protected void connectionFailed(java.nio.channels.SocketChannel channel,
                                    java.lang.Throwable ex,
                                    java.lang.Object attachment)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.